// The module 'vscode' contains the VS Code extensibility API
// Import the module and reference it with the alias vscode in your code below
import * as vscode from 'vscode';

// This method is called when your extension is activated
// Your extension is activated the very first time the command is executed
export function activate(context: vscode.ExtensionContext) {

	// Use the console to output diagnostic information (console.log) and errors (console.error)
	// This line of code will only be executed once when your extension is activated
	console.log('Congratulations, your extension "terminal-completion-sample" is now active!');

    const terminalProvider = {
       id: 'exampleShell', 
       async provideTerminalCompletions(terminal: vscode.Terminal, terminalContext: { commandLine: string; cursorPosition: number }, token: vscode.CancellationToken): Promise<vscode.TerminalCompletionItem[] | vscode.TerminalCompletionList | undefined> {
			if (token.isCancellationRequested) {
				return;
			}

            return [{label: 'reply-item-1', replacementIndex: 0, replacementLength: 1, detail: 'sample detail for reply-item-1'}];
        }
    };

	// Register terminal completion provider
    const terminalCompletionProvider = vscode.window.registerTerminalCompletionProvider(terminalProvider);

    context.subscriptions.push(terminalCompletionProvider);

    const disposable = vscode.commands.registerCommand('terminal-completion-sample.helloWorld', () => {
        vscode.window.showInformationMessage('Hello World from terminal-completion-sample!');
    });

    context.subscriptions.push(disposable);
}

// This method is called when your extension is deactivated
export function deactivate() {}
